<?php
// 仮想バッチ処理
// cronとかat使わずに定時処理(っぽい)ことをする

function batchAll()
{
	batchEveryTime();
	batchHourly();
	batchDaily();
	batchMonthly();
}

function batchEveryTime()
{
	// 期限を過ぎたUNIQUEKEYファイルを抹消
	batchPurgeOldUniquekeyFile();
	// ダウンロード期限を過ぎた行を削除
	batchPurgeDownloadLimitOverLine();
}

function batchHourly()
{
	global $gSys;
	$d = dir($gSys['dir']['log'].'timer/hourly/');
	while (false !== ($entry = $d->read())) {
		$entry=trim($entry);
		if($entry=='')
			continue;
		if(ereg('/',$entry))
			continue;
		if(ereg('^[\.]+$',$entry))
			continue;
		$mtime=filemtime($gSys['dir']['log'].'timer/hourly/'.$entry);
		if($mtime < time()-(integer)(60*61)){	// 61分以上経過しているもの
			unlink($gSys['dir']['log'].'timer/hourly/'.$entry);	// 削除
		}
	}
	$d->close();
	$hourlyTimerFileName=$gSys['dir']['log'].'timer/hourly/'.date('H');
	if(file_exists($hourlyTimerFileName))
		$sw=true;
	else
		$sw=false;
	if($gSys['sys']['access_counter'])
		file_put_contents($hourlyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	elseif(!$sw)	// アクセスカウント停止の場合は最初の１回だけ
		file_put_contents($hourlyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	
	if($sw)
		return false;	// 既に本日分処理済
	
	// 以下に処理を記述
	
	
	return true;
}
function batchDaily()
{
	global $gSys;
	$dailyTimerFileName=$gSys['dir']['log'].'timer/daily/'.date('Ymd');
	if(file_exists($dailyTimerFileName))
		$sw=true;
	else
		$sw=false;
	if($gSys['sys']['access_counter'])
		file_put_contents($dailyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	elseif(!$sw)	// アクセスカウント停止の場合は最初の１回だけ
		file_put_contents($dailyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	if($sw)
		return false;	// 既に本日分処理済
	
	// 以下に処理を記述
	
	
	return true;
}

function batchMonthly()
{
	global $gSys;
	if(!is_writable($gSys['dir']['log'].'timer/monthly'))
		exit('log/timer/monthly ディレクトリに書き込みできません');
	$monthlyTimerFileName=$gSys['dir']['log'].'timer/monthly/'.date('Ym');
	if(file_exists($monthlyTimerFileName))
		$sw=true;
	else
		$sw=false;
	if($gSys['sys']['access_counter'])
		file_put_contents($monthlyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	elseif(!$sw)	// アクセスカウント停止の場合は最初の１回だけ
		file_put_contents($monthlyTimerFileName,'.',FILE_APPEND);	// ファイルに１バイト追加
	if($sw)
		return false;	// 既に今月分処理済
	
	// 以下に処理を記述
	checkDirExists();
	
	return true;
}

// 必要なディレクトリが存在するか確認
function checkDirExists()
{
	global $gSys;

	// data
	if(!is_dir($gSys['dir']['data']))
		exit('data ディレクトリが存在しません');

	// log
	if(!is_dir($gSys['dir']['log']))
		exit('log ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log']))
		exit('log ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'uniquekey'))
		exit('log/uniquekey/ ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'uniquekey'))
		exit('log/uniquekey/ ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'uniquekey'))
		exit('log/uniquekey/ ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'uniquekey'))
		exit('log/uniquekey/ ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'daily'))
		exit('log/daily/ ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'daily'))
		exit('log/daily/ ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'timer'))
		exit('log/timer/ ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'timer'))
		exit('log/timer/ ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'timer/hourly'))
		exit('log/timer/hourly ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'timer/hourly'))
		exit('log/timer/hourly ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'timer/daily'))
		exit('log/timer/daily ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'timer/daily'))
		exit('log/timer/daily ディレクトリに書き込みできません');

	if(!is_dir($gSys['dir']['log'].'timer/monthly'))
		exit('log/timer/monthly ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'timer/monthly'))
		exit('log/timer/monthly ディレクトリに書き込みできません');

	// dl_counter
	if(!is_dir($gSys['dir']['log'].'dl_counter'))
		exit('log/dl_counter ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'dl_counter'))
		exit('log/dl_counter ディレクトリに書き込みできません');

	// trade_counter
	if(!is_dir($gSys['dir']['log'].'trade_counter'))
		exit('log/trade_counter ディレクトリが存在しません');
	if(!is_writable($gSys['dir']['log'].'trade_counter'))
		exit('log/trade_counter ディレクトリに書き込みできません');

	return true;
}


// 期限を過ぎたUNIQUEKEYファイルを抹消
function batchPurgeOldUniquekeyFile()
{
	global $gSys;
	$d = dir($gSys['dir']['log'].'uniquekey/');
	while (false !== ($entry = $d->read())) {
		$entry=trim($entry);
		if($entry=='')
			continue;
		if(ereg('/',$entry))
			continue;
		if(ereg('\.\.',$entry))
			continue;
		if(ereg('^[\.]+$',$entry))
			continue;
		$mtime=filemtime($gSys['dir']['log'].'uniquekey/'.$entry);
		if($mtime < time()-$gSys['moritapo']['uniquekey_expiration_time']){
			unlink($gSys['dir']['log'].'uniquekey/'.$entry);	// 削除
		}
	}
	$d->close();

}

// ダウンロード期限を過ぎた行を削除
function batchPurgeDownloadLimitOverLine()
{
	global $gSys;
	$nowTime=time();
	if(!file_exists($gSys['dir']['log'].'dl_allow.log'))
		return;
	// 前回更新時より60秒以上経過しないと処理しない
	if(filemtime($gSys['dir']['log'].'dl_allow.log') + 60 > $nowTime){
		return;
	}
	$fp = fopen($gSys['dir']['log'].'dl_allow.log', "r+");
	if (!flock($fp, LOCK_EX)) { // 排他的ロックを行う
	    echo "Couldn't lock the file !";
		return;
	}
	$data='';
	$change=false;
	while (!feof($fp)) {
		$buffer = fgets($fp, 4096);
		$lines=explode("\t",$buffer);
		if($lines[6] < $nowTime){
			$change=true;
			continue;
		}
		$data.=$buffer;
	}
	if($change){
		rewind($fp);
		ftruncate ($fp, 0);
		if (fwrite($fp, $data) === FALSE) {
			echo "Cannot write to dl_allow file";
		}
	}
	flock($fp, LOCK_UN); // ロックを解放する
	fclose($fp);
}


?>
