<?php
/*
	このファイルについて：
	クライアントへの出力関連(平たく言えばブラウザへ渡すデータ関連)が
	まとめられているファイルです
*/

/*
  HTTPヘッダ部出力関数
*/
function do_mod_header_out()
{
	global $gSys;
	if(headers_sent())
		return;
	if(!empty($gSys['out']['header']['HTTP']))
		header('HTTP/1.1 '.$gSys['out']['header']['HTTP']);
	if(!empty($gSys['out']['header']['Date']))
		header('Date: '.$gSys['out']['header']['Date']);
	if(!empty($gSys['out']['header']['Expires']))
		header('Expires: '.$gSys['out']['header']['Expires']);
	if(!empty($gSys['out']['header']['Last-Modified']))
		header('Last-Modified: '.$gSys['out']['header']['Last-Modified']);
	if(!empty($gSys['out']['header']['Cache-Control']))
		header('Cache-Control: '.$gSys['out']['header']['Cache-Control']);
	if(!empty($gSys['out']['header']['Pragma']))
		header('Pragma: '.$gSys['out']['header']['Pragma']);
	if(!empty($gSys['out']['header']['Content-Type']))
	{
		header('Content-Type: '.$gSys['out']['header']['Content-Type']);
	}
	if(!empty($gSys['out']['header']['Location']))
		header('Location:'.$gSys['out']['header']['Location']);
	if(is_array($gSys['out']['header']['Other']))
	{
		foreach($gSys['out']['header']['Other'] as $val)
		{
			header($val);
		}
	}
}

function _disp($search,$replace,$tpl)
{
	global $gSys;
	$header=$footer=$body='';
	// ヘッダーテンプレート置換
	if(file_exists($gSys['dir']['mod'].'common_tpl/header.tpl')){
		$headerTpl=file_get_contents($gSys['dir']['mod'].'common_tpl/header.tpl');
		if(is_array($gSys['tpl']['header']['search']) and is_array($gSys['tpl']['header']['replace'])){
			$header =& str_replace($gSys['tpl']['header']['search'], $gSys['tpl']['header']['replace'], $headerTpl);
		}else{
			$header =& $headerTpl;
		}
	}
	// フッターテンプレート置換
	if(file_exists($gSys['dir']['mod'].'common_tpl/footer.tpl')){
		$footerTpl=file_get_contents($gSys['dir']['mod'].'common_tpl/footer.tpl');
		if(is_array($gSys['tpl']['footer']['search']) and is_array($gSys['tpl']['footer']['replace'])){
			$footer =& str_replace($gSys['tpl']['footer']['search'], $gSys['tpl']['footer']['replace'], $footerTpl);
		}else{
			$footer =& $footerTpl;
		}
	}
	$bodyTpl=file_get_contents($tpl);
	$bodyTpl=$header.$bodyTpl.$footer;
	if(file_exists($tpl)){
		if(is_array($search) and is_array($replace)){
			$body =& str_replace($search, $replace, $bodyTpl); // ボディテンプレート置換
		}
	}
	echo $body;
	flush();
}

/*
  クライアントへの画面出力関数
*/
function do_mod_disp()
{
	global $gSys;
	do_mod_header_out();
	if(!empty($gSys['error']['message']))
	{
		$search=array(
			'%%STORE_NAME%%',
			'%%MESSAGE%%',
			'%%ERROR_BACK_URL%%'
			);
		$replace=array(
			$gSys['myservice']['service_name'],
			$gSys['error']['message'],
			($gSys['error']['back_url']=='')?$gSys['config']['store_index_url']:$gSys['error']['back_url']
			);
		_disp($search, $replace, $gSys['error']['tpl']); // ボディテンプレート置換
	}
	_disp($gSys['tpl']['search'], $gSys['tpl']['replace'], $gSys['tpl']['file']); // ボディテンプレート置換
}

/*
 シンプルなXHTML出力
*/
function xhtml_out($title,$body,$filename="",$h1="",$keywords,$description)
{
	$head=
'<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Pragma" content="no-cache" />
<meta name="KEYWORDS" content="'.$keywords.'" />
<meta name="DESCRIPTION" content="'.$description.'" />
<title>'.$title.'</title>
<link rel="stylesheet" type="text/css" href="http://toha.jp/css/style.css" />
</head>
<body>';
	if($h1!="")
		$head.='<h1>'.$title.'</h1>';
	$head.='<div id="words">';

	$foot=
'</div>
</body>
</html>
';
	if(empty($filename))
		print $head.$body.$foot;
	else
		file_put_contents(OUTDIR.$filename,$head.$body.$foot);
	return;
}

?>