<?php
/*
	このファイルについて：
	サニタイズ及び入力値整理に関連する関数がまとめられているファイルです
*/

function &sanitize(&$param)
{
	if (is_array($param))
	{
		$result = array_map('sanitize',$param);
	}
	else
	{
		$result = str_replace("\0",'',$param);
		if (get_magic_quotes_gpc())
		{
			$result = stripslashes($result);
		}
	}
	return $result;
}
function &sanitize_no_stripslashes(&$param)
{
	if (is_array($param))
	{
		$result = array_map('sanitize_no_stripslashes',$param);
	}
	else
	{
		$result = str_replace("\0",'',$param);
	}
	return $result;
}

function &sanitize_all_input()
{
	$get    = sanitize($_GET);
	$post   = sanitize($_POST);
	$cookie = sanitize($_COOKIE);
	$files = sanitize_no_stripslashes($_FILES);
	$session = sanitize_no_stripslashes($_SESSION);

	$method = sanitize($_SERVER['REQUEST_METHOD']);	// httpd に渡されたときのmethod
	$post_input_stream  = sanitize(file_get_contents("php://input"));

	// QUERY_STRINGを取得
	// また、URI を urlencode せずに手打ちで入力した場合に対処する為
	$arg = '';
	if ($_SERVER['QUERY_STRING'] != '')
	{
		$arg = $_SERVER['QUERY_STRING'];
	}
	else if (array_key_exists(0,$_SERVER['argv']))
	{
		$arg = $_SERVER['argv'][0];
	}
	// サニタイズ (\0 除去)
	$arg = sanitize($arg);
	
	// URI 手打の場合、コード変換し、get[] に上書き
	// mb_convert_variablesのバグ(?)対策 配列で渡さないと落ちる
	$arg = array($arg);
	mb_convert_variables('UTF-8','auto',$arg);
	$arg = $arg[0];
	
	foreach (explode('&',$arg) as $tmp_string)
	{
		if (preg_match('/^([^=]+)=(.+)/',$tmp_string,$matches)
			and mb_detect_encoding($matches[2]) != 'ASCII')
		{
			$get[$matches[1]] = $matches[2];
		}
	}
	

	// PATH_INFO(for test)
	if(isset($_SERVER['PATH_INFO']))
	{
		$pairs = explode('/',$_SERVER['PATH_INFO']);
		$command=$pairs[1];	// command
		$option=$pairs[2];	// option
		unset($pairs[0],$pairs[1],$pairs[2]);
		$values=array();
		foreach($pairs as $val)
			$values[]=$val;
	}elseif(isset($_GET[p])){
		$pairs = explode('/',$get[p]);
		$command=$pairs[0];	// command
		$option=$pairs[1];	// option
		unset($pairs[0],$pairs[1]);
		foreach($pairs as $val)
			$values[]=$val;
	}else{
		$pairs = array();
	}

	$vars = array_merge($post,$get);

	$in = array(
		'method' => $method,
		'control' => array(
			'command' => $command,
			'option' => $option,
			'values' => $values
		),
		'values' => $vars,
		'cookie' => $cookie,
		'files' => $files,
		'session' => $session,
		'input' => $post_input_stream
	);
	return $in;
}

?>