<?php
// 簡単モリタピから返事をもらう

require_once($gSys['dir']['lib'].'inc/moritapo_errors.inc.php');	// エラーメッセージ集

function main()
{
	global $gSys;
	global $gMoritapoErrors;
	require_once($gSys['dir']['mod'].'common.func.php');
	require_once($gSys['dir']['lib'].'func/moritapo.func.php');

	///////////
	// エラー処理
	///////////
	$gSys['error']['tpl']=$gSys['dir']['mod'].'return/back_error.tpl';
	$retAmount=$gSys['in']['values']['AMOUNT'];
	$retUniquekey=$gSys['in']['values']['UNIQUEKEY'];
	$retErr=$gSys['in']['values']['ERR'];
	$retMd5key=$gSys['in']['values']['MD5KEY'];
	if(''==$retAmount){
		$gSys['error']['message'].='必要な値が返されませんでした(AMOUNT).<br />';
		return;
	}
	if(''==$retUniquekey){
		$gSys['error']['message'].='必要な値が返されませんでした(UNIQUEKEY).<br />';
		return;
	}
	if(''==$retErr){
		$gSys['error']['message'].='必要な値が返されませんでした(ERR).<br />';
		return;
	}
	if(''==$retMd5key){
		$gSys['error']['message'].='必要な値が返されませんでした(MD5KEY).<br />';
		return;
	}

	// 返されるべきMD5値を生成
	$trueMd5key=genMoritapoEasyapiMd5KeyWithErrNo($retAmount,$retUniquekey,$retErr);
	// MD5KEY 照会
	if($retMd5key!=$trueMd5key){
		$gSys['error']['message'].='値の照会に失敗しました(MD5KEY).<br />';
		return;
	}
	if($retErr!='000'){
		$gSys['error']['message'].='決済処理に失敗しました(ERR:'.$retErr.').<br />';
		$gSys['error']['message'].=$gMoritapoErrors[$retErr].'<br />';
		
		return;
	}
	if(!file_exists($gSys['dir']['log'].'uniquekey/'.$retUniquekey)){
		$gSys['error']['message'].='所定の時間内に購入がおこなわれませんでした(UNIQUEKEY/'.
			secondFormat($gSys['moritapo']['uniquekey_expiration_time']).'以内).<br />';
		return;
	}
	$lockFilePoint=exFileLock($gSys['dir']['log'].'uniquekey/'.$retUniquekey);

	///////////
	// 課金成功
	///////////
	$uniquekeyFileText=file_get_contents($gSys['dir']['log'].'uniquekey/'.$retUniquekey);
	exFileUnlock($lockFilePoint);
	$uniquekeyFileDataSet=explode("\n",$uniquekeyFileText);
	$dlFileInfo=array(); // ダウンロードファイルの詳細
	$dlFileInfo['filename']=trim($uniquekeyFileDataSet[0]);
	$dlFileInfo['price']=trim($uniquekeyFileDataSet[1]);
	$dlFileInfo['title']=trim($uniquekeyFileDataSet[2]);
	$dlFileInfo['description']=trim($uniquekeyFileDataSet[3]);
	$dlFileInfo['utime']=trim($uniquekeyFileDataSet[4]);
	$dlFileInfo['ip']=trim($uniquekeyFileDataSet[5]);

	// 既に課金記録済みでログにも入っているかどうかチェック
	$tradeDone=chkDownloadEnable($dlFileInfo['filename'],$retUniquekey);

	// 成功ログ記録準備
	$fileDataSet =& getFileDetailData($dlFileInfo['filename']);	// ファイル詳細情報取得
	$nowTime=time();
	$logLine='';
	$logLine.=$retUniquekey."\t";	// 0:coupon(uniquekey)
	$logLine.=(string)$nowTime."\t";	// 1:今の時間 UNIXTIME
	$logLine.=$fileDataSet['md5']."\t";	// 2:md5_time
	$logLine.=$dlFileInfo['filename']."\t";	// 3:ファイル名
	$logLine.=$dlFileInfo['price']."\t";	// 4:モリタポ
	$logLine.=$dlFileInfo['title']."\t";	// 5:タイトル
	$logLine.=(string)($nowTime + $gSys['config']['download_expiration_time'])."\t";	// 6:ダウンロード期限
	$logLine.=$dlFileInfo['ip']."\n";	// 7:ipアドレス
	// 成功ログ記録
	if(!$tradeDone){	// ログへの二重記録を防ぐ
		// ダウンロード許可ログへ追加書き込み(所定期間内のダウンロードを許可)
		file_put_contents($gSys['dir']['log'].'dl_allow.log',$logLine,FILE_APPEND);
		// デイリーログへ追加書き込み
		file_put_contents($gSys['dir']['log'].'daily/'.date('Ymd',$nowTime).'.log',$logLine,FILE_APPEND);
		// 決済成功数カウンター
		if($gSys['sys']['trade_counter'])
			file_put_contents($gSys['dir']['log'].'trade_counter/'.$dlFileInfo['filename'],'.',FILE_APPEND);
	}
	if(!$tradeDone){
		// 購入日時
		$buyDateTimeFormatted=date('Y/m/d H:i:s',$nowTime);
	}else{	// 既に購入記録済
		if(false!==$allowRecord=getDownloadAllowRecord($coupon))
			$buyDateTimeFormatted=date('Y/m/d H:i:s',(integer)$allowRecord[1]);
		else
			$buyDateTimeFormatted='既に購入済です';
	}
	// ダウンロードURL
	$dl_url=$gSys['config']['store_index_url'].'?p=view/download&filename='.$fileDataSet['filename'].'&coupon='.$retUniquekey;
	setcookie('trade_filename['.$dlFileInfo['filename'].']',$retUniquekey,$gSys['config']['trade_filename_cookie_lifetime_sec'],'/');

	// テンプレート
	$gSys['tpl']['search']=array(
		'%%FILE_TITLE%%',
		'%%FILE_PRICE%%',
		'%%FILE_PRICE_DISP%%',
		'%%FILE_DESCRIPTION%%',
		'%%FILE_NAME%%',
		'%%FILE_MD5%%',
		'%%FILE_SIZE%%',
		'%%FILE_MOD_TIME%%',
		'%%STORE_NAME%%',
		'%%SERVICER%%',
		'%%RET_URL%%',
		'%%UNIQUEKEY%%',
		'%%BUY_DATETIME%%',
		'%%DL_EXPIRATION_TIME%%',
		'%%DL_URL%%',
		'%%BACK_URL%%'
		);
	$gSys['tpl']['replace']=array(
		$fileDataSet['title'],
		$fileDataSet['price'],
		number_format($fileDataSet['price']),
		$fileDataSet['description'],
		$fileDataSet['filename'],
		$fileDataSet['md5'],
		number_format($fileDataSet['size']),
		$fileDataSet['mod_time'],
		$gSys['myservice']['service_name'],
		$gSys['moritapo']['servicer'],
		$gSys['moritapo']['ret_url'],
		$retUniquekey,
		$buyDateTimeFormatted,
		secondFormat($gSys['config']['download_expiration_time']),
		$dl_url,
		$gSys['config']['store_index_url']
		);


}


?>